## TI-RSLK MAX Debug Application

Exercise basic robot functions using the GUI interface. Use this tool for initial testing and sanity checking. The test program will automatically download when the TI-RSLK is connected over USB. 

Six AA batteries must be installed for the tests to work. Make sure the 5V pin on the MSP432 LaunchPad debugger is NOT connected to avoid damage to the motor board

>*You must close this README to proceed with the tool.* 

---

**Bump Switches**

TI-RSLK includes 6 forward mounted bump switches. When bump switches are pressed it should be indicated on the GUI. Red indicates switch not activated, Black indicates switch activated. The switches are connected to the MSP432 LaunchPad as follows:

- Bump 0 connected to P4.0 (J3)
- Bump 1 connected to P4.2 (J3)
- Bump 2 connected to P4.3 (J1)
- Bump 3 connected to P4.5 (J3)
- Bump 4 connected to P4.6 (J1)
- Bump 5 connected to P4.7 (J3)

**Push Buttons**

TI-RSLK has a main power switch for turning off motor board. Batteries must be connected for main power to work for line sensor and motors. Power ON by sliding switch to ON position, Power OFF by sliding switch to OFF position and pushing the Power button. The MSP432 LaunchPad has two switches connected as follows: 

- LP S1 connected to P1.1
- LP S2 connected to P1.4

**Line Sensor**

TI-RSLK has a IR reflectance sensor mounted to the bottom. When IR thresholds have been changed in front of line sensor it should be indicated on the GUI. Red indicates no reflectance detected, Black indicates a reflectance is detected. The line sensor is connected to the MSP432 as follows: 

- Reflectance0 connected to P7.0 (J5)
- Reflectance1 connected to P7.1 (J5)
- Reflectance2 connected to P7.2 (J5)
- Reflectance3 connected to P7.3 (J5)
- Reflectance4 connected to P7.4 (J5)
- Reflectance5 connected to P7.5 (J5)
- Reflectance6 connected to P7.6 (J5)
- Reflectance7 connected to P7.7 (J5)

**LEDs**

Light Emitting Diodes are very useful for testing as visual indicators. TI-RSLK has 4 LEDs on the motor board and one red LED and one RGB LED on the MSP432 LaunchPad. LEDs are connected to the MSP432 LaunchPad as follows:

- RSLK Front Right connected to P8.5
- RSLK Back Right connected to P8.7
- RSLK Front Left connect to P8.0
- RSLK Back Left connected to P8.6
- LP Red connected to P1.0
- LP RGB Green connected to P2.1
- LP RGB Blue connected to P2.2
- LP RGB Red connected to P2.0

**Motor Control**

The motor duty cycles (PWM values) can be adjusted using the GUI sliders or the left and right pushbuttons on the MSP432. Reverse the motor direction by toggling the respective radio buttons. The motors are connected to the MSP432 LaunchPad as follows:

- Left Motor PWM connected to P2.7 (J4)
- Left Motor DIR connected to P5.4 (J3)
- Left Motor nSLP connected P3.7 (J4)
- Right Motor PWM connected to P2.6 (J4)
- Right Motor DIR connected to P5.5 (J3)
- Right Motor nSLP connected to P3.6 (J2)


**Encoders**

Each motor encoder should to be connected to the MSP432 as follows:

- Left Encoder A connected to P10.5 (J5)
- Left Encoder B connected to P5.2 (J2)
- Right Encoder A connected to P10.4 (J5)
- Right Encoder B connected to P5.0 (J2)
  
Pololu encoder has 12 counts per revolution (counting all 4 edges). The motor has a gearbox with a 120:1 ratio. This gives 12*120 = 1440 counts per revolution of the wheel. Since we are only counting one edge of the encoder we need to divide by 4 for a total of 360 counts per revolution.


**Additional Resources**

This tool is created with MSP432 Driver Library. Source code for GUI and firmware are available. 

Created in collaboration with UCF TI Innovation Lab.

